package org.dromara.personnel.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.personnel.domain.dto.OpsBeipinBeijianDto;
import org.dromara.personnel.domain.vo.OpsBeipinBeijianCountVo;
import org.dromara.personnel.service.IOpsCaigouPlanChanpinService;
import org.dromara.personnel.service.IOpsCaigouPlanService;
import org.springframework.stereotype.Service;
import org.dromara.personnel.domain.bo.OpsBeipinBeijianBo;
import org.dromara.personnel.domain.vo.OpsBeipinBeijianVo;
import org.dromara.personnel.domain.OpsBeipinBeijian;
import org.dromara.personnel.mapper.OpsBeipinBeijianMapper;
import org.dromara.personnel.service.IOpsBeipinBeijianService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-物资-备品配件Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-24
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsBeipinBeijianServiceImpl extends ServiceImpl<OpsBeipinBeijianMapper,OpsBeipinBeijian> implements IOpsBeipinBeijianService {

    private final OpsBeipinBeijianMapper baseMapper;

    private final IOpsCaigouPlanChanpinService caigouPlanChanpinService;

    /**
     * 查询运维-物资-备品配件
     *
     * @param id 主键
     * @return 运维-物资-备品配件
     */
    @Override
    public OpsBeipinBeijianVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-物资-备品配件列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-物资-备品配件分页列表
     */
    @Override
    public TableDataInfo<OpsBeipinBeijianVo> queryPageList(OpsBeipinBeijianBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsBeipinBeijian> lqw = buildQueryWrapper(bo);
        Page<OpsBeipinBeijianVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-物资-备品配件列表
     *
     * @param bo 查询条件
     * @return 运维-物资-备品配件列表
     */
    @Override
    public List<OpsBeipinBeijianVo> queryList(OpsBeipinBeijianBo bo) {
        LambdaQueryWrapper<OpsBeipinBeijian> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsBeipinBeijian> buildQueryWrapper(OpsBeipinBeijianBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsBeipinBeijian> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsBeipinBeijian::getId);
        lqw.eq(bo.getProjectId() != null, OpsBeipinBeijian::getProjectId, bo.getProjectId());
        lqw.eq(StringUtils.isNotBlank(bo.getBeijianNumber()), OpsBeipinBeijian::getBeijianNumber, bo.getBeijianNumber());
        lqw.like(StringUtils.isNotBlank(bo.getBeijianName()), OpsBeipinBeijian::getBeijianName, bo.getBeijianName());
        lqw.eq(StringUtils.isNotBlank(bo.getShebeiType()), OpsBeipinBeijian::getShebeiType, bo.getShebeiType());
        lqw.eq(StringUtils.isNotBlank(bo.getGuigexinghao()), OpsBeipinBeijian::getGuigexinghao, bo.getGuigexinghao());
        lqw.eq(StringUtils.isNotBlank(bo.getKucunStatus()), OpsBeipinBeijian::getKucunStatus, bo.getKucunStatus());
        lqw.eq(bo.getKucunCount() != null, OpsBeipinBeijian::getKucunCount, bo.getKucunCount());
        return lqw;
    }

    /**
     * 新增运维-物资-备品配件
     *
     * @param bo 运维-物资-备品配件
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsBeipinBeijianBo bo) {
        OpsBeipinBeijian add = MapstructUtils.convert(bo, OpsBeipinBeijian.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-物资-备品配件
     *
     * @param bo 运维-物资-备品配件
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsBeipinBeijianBo bo) {
        OpsBeipinBeijian update = MapstructUtils.convert(bo, OpsBeipinBeijian.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsBeipinBeijian entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-物资-备品配件信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public TableDataInfo<OpsBeipinBeijianDto> getList(OpsBeipinBeijianBo bo, PageQuery pageQuery) {
        Page<OpsBeipinBeijianDto> result = caigouPlanChanpinService.getBeiJianList(pageQuery.build(),bo);
        result.getRecords().forEach(item -> {
           item.setKucunCount(item.getRuKuCount()-item.getChuKuCount());
           if (item.getKucunCount() == 0){
               item.setKucunStatus("2");
           }
           if (item.getRuKuCount() > 0 && item.getRuKuCount() / 2 > item.getKucunCount()){
               item.setKucunStatus("1");
           }
           if (item.getRuKuCount() > 0 && item.getRuKuCount() / 2 < item.getKucunCount()){
               item.setKucunStatus("0");
           }
        });
        return TableDataInfo.build(result);
    }

    @Override
    public OpsBeipinBeijianCountVo getCount(OpsBeipinBeijianBo bo) {
        List<OpsBeipinBeijianDto> records = caigouPlanChanpinService.getCount(bo);
        OpsBeipinBeijianCountVo vo = new OpsBeipinBeijianCountVo();
        long zonCount = 0L;
        long diCount = 0L;
        Map<String, Long> map = new HashMap<>();
        for (OpsBeipinBeijianDto item : records) {
            long kucunCount = item.getRuKuCount() - item.getChuKuCount();
            zonCount += kucunCount;
            if (kucunCount == 0 || (item.getRuKuCount() > 0 && item.getRuKuCount() / 2 > item.getKucunCount())){
                diCount++;
            }
            if (!map.containsKey(item.getShebeiType())) {
                map.put(item.getShebeiType(), kucunCount);
            }else {
                map.put(item.getShebeiType(), map.get(item.getShebeiType()) + kucunCount);
            }
        }
        vo.setZonCount(zonCount);
        vo.setDiCount(diCount);
        vo.setTypeCount(map);
        return vo;
    }
}
